;
;	$RANDOM - SVC 20
;	'random' number generator
;
;	ENT	B = limit value (2-255)
;
;	EXT	C = random number, range 0,B-1
;		if B = 0 or 1, then return C = 0
;		A = 0
;		Z set
;
; (NOTE) does NOT use clock to generate numbers
;
RANDOM	LD	A,B		;get limit value
	OR	A		;z?
	JR	Z,RANRET	;return if yes
	DEC	A		;1?
	JR	Z,RANRET	;return if yes
	CALL	RAND0		;get random number
;
;	force 'random' number to specified limit
;
RANDM1	CP	B		;within limit?
	JR	C,RANRET	;go if yes
	SUB	B		;else force limit
	JR	RANDM1		;try again
RANRET	LD	C,A		;put it here
	XOR	A		;set Z
	RET			;go
;
;	generate 'random' number
;
RAND0	LD	A,R		;get initial 'seed'
	XOR	37H
RAND1	EQU	$-1
	LD	(RAND3),A
	RRCA
	RRCA
	XOR	2FH
RAND2	EQU	$-1
	LD	(RAND1),A
	RLA
	XOR	77H
RAND3	EQU	$-1
	LD	(RAND2),A
	RET			;done
;
